/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package lightcontainer;

import lightcontainer.domains.server.MulticastServerListener;
import lightcontainer.domains.server.UnicastServerListener;
import lightcontainer.interfaces.MulticastSPR;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.rules.reader.HelloRule;
import lightcontainer.repository.ClientHandlerRepository;
import lightcontainer.repository.FileFrontEnd;
import lightcontainer.repository.ProtocolRepositoryImpl;
import lightcontainer.repository.StoreProcessorRepository;

public class App {
    // Constant config server
    // -- Unicast client port
    private static final int UNICAST_PORT = 8500;
    // -- Multicast listener ip, port
    private static final String MULTICAST_IP = "226.66.66.1";
    private static final int MULTICAST_PORT = 42500;

    public static void main(String[] args) throws InterruptedException {
        // Create all repository
        ClientHandlerRepository clientRep = new ClientHandlerRepository();
        StoreProcessorRepository storeRep = new StoreProcessorRepository();
        ProtocolRepository protocolRep = new ProtocolRepositoryImpl();

        protocolRep.addReader(new HelloRule());

        new UnicastServerListener(clientRep, UNICAST_PORT);
        new MulticastServerListener(storeRep, protocolRep, MULTICAST_IP, MULTICAST_PORT);
        FileFrontEnd ffe = new FileFrontEnd(clientRep, storeRep);

        // close repo et client et server.

        Thread.sleep(60000);

        clientRep.close();
        storeRep.close();
    }
}
