package lightcontainer.protocol.rules.reader;

import lightcontainer.protocol.ProtocolReader;

import java.util.ArrayList;
import java.util.List;

public class HelloRule extends ProtocolReader {

    private static final  String PATTERN = "^HELLO ([A-Za-z0-9]{5,20}) ([0-9]{1,5})\r\n$";

    // Index du domain dans le tableau de donnée
    private static final int DOMAIN = 0;

    //Index du port dans le tableau de donnée
    private static final int PORT = 1;

    public HelloRule() {
        super(PATTERN);
    }


    public class Result extends ProtocolResult {

        private final String domain;
        private final int port;

        public Result(String domain, int port) {
            this.domain = domain;
            this.port = port;
        }

        public String getDomain() {
            return domain;
        }

        public int getPort() {
            return port;
        }
    }


    @Override
    protected HelloRule.Result onExecuted(String... data) {
        String domain = data[DOMAIN];
        int port = Integer.parseInt(data[PORT]);

        return new HelloRule.Result(domain, port);
    }

}
